import java.awt.event.*;
import java.awt.*;


public class Pentagram2 {

    /**Here is the basic map*/    
   public static double[] map(double[] x) {
       return A(delta(x));
   }

    public static double[] delta(double[] A) {
	double a=A[0];
	double b=A[1];
	double c=A[2];
	double d=A[3];
	double[] f={(b*(1 + c + d))/(c*(1 + a + c + a*c + b*d)),(d*(b + c + a*c + b*d))/(c*(1 + a + c + a*c + b*d)),
		    ((1 + a + b)*d)/(a*(1 + a + c + a*c + b*d)),(b*(a + a*c + d + b*d))/(a*(1 + a + c + a*c + b*d))};
	return f;
    }
    
    public static double[] A(double[] x) {
	double[] B={-x[1],-x[0],-x[3],-x[2]};
	return B;
    }

    /**These are the better invariants*/
    public static double F1(double[] A) {
	double a=A[0];
	double b=A[1];
	double c=A[2];
	double d=A[3];
	double t=a*c+b*d;
	double f=(1+a-b)*(1+c-d)*(t+d-a)*(t+b-c);
	f=f/(a*b*c*d);
	return f;
    }
    
    public static double F2(double[] A) {
	double a=A[0];
	double b=A[1];
	double c=A[2];
	double d=A[3];
	double t=a*c+b*d;
	double f=(1+b-a)*(1+d-c)*(t+a-d)*(t+c-b);
	f=f/(a*b*c*d);
	return f;
    }
    
    /**Here are the components of F1*/
    public static double[] FF1(double[] A) {
	double a=A[0];
	double b=A[1];
	double c=A[2];
	double d=A[3];
	double t=a*c+b*d;
	double[] f={(1+a-b),(1+c-d),(t+d-a),(t+b-c),a*b*c*d};
	return f;
    }
    
    /**Here are the components of F2*/
    public static double[] FF2(double[] A) {
	double a=A[0];
	double b=A[1];
	double c=A[2];
	double d=A[3];
	double t=a*c+b*d;
	double[] f={(1+b-a),(1+d-c),(t+a-d),(t+c-b),a*b*c*d};
     	return f;
    }

    public static double p(double x,int k) {
	return Math.pow(x,k);
    }

}



