(*This file checks the gradient formulas in Lemma 2.4*)


Clear[a,b,c,d,h];
h[{a_,b_,c_,d_}]:=Log[a c/b/d];

GRAD[f_]:={D[f,a],D[f,b],D[f,c],D[f,d]}

 
XG = {-(a*b*(2*(-2/a - (1 - a^2 - b^2)/(a*b^2))*(a - b + c - d) - 
        2*((1 - a^2 - b^2)/(a*b) + (1 - c^2 - d^2)/(c*d)))), 
     a*b*(2*(-2/b - (1 - a^2 - b^2)/(a^2*b))*(a - b + c - d) + 
       2*((1 - a^2 - b^2)/(a*b) + (1 - c^2 - d^2)/(c*d))), 
     -(c*d*(2*(a - b + c - d)*(-2/c - (1 - c^2 - d^2)/(c*d^2)) - 
        2*((1 - a^2 - b^2)/(a*b) + (1 - c^2 - d^2)/(c*d)))), 
     c*d*(2*(a - b + c - d)*(-2/d - (1 - c^2 - d^2)/(c^2*d)) + 
       2*((1 - a^2 - b^2)/(a*b) + (1 - c^2 - d^2)/(c*d)))}




    grad1=Simplify[XG.GRAD[g2[a,b]]];
    goal1=2 (g2[a,b] + g2[c,d]) (1-a+b) (1+a-b) (a+b)/a/b;
    Print[goal1];   
    Print[Simplify[grad1-goal1]]

    grad2=Simplify[XG.GRAD[g2[c,d]]];
      goal2=2 (g2[a,b] + g2[c,d]) (1-c+d) (1+c-d) (c+d)/c/d;
    Print[goal2];   
    Print[Simplify[grad2-goal2]]
    
    grad3=Simplify[XG.GRAD[g1[a,b]]];
    goal3=-2 (g1[a,b] + g1[c,d]) (1-a+b) (1+a-b) (a+b)/a/b;
    Print[goal3];   
    Print[Simplify[grad3-goal3]]

    grad4=Simplify[XG.GRAD[g1[c,d]]];
    goal4=-2 (g1[a,b] + g1[c,d]) (1-c+d) (1+c-d) (c+d)/c/d;
    Print[goal4];   
    Print[Simplify[grad4-goal4]]

    grad5=Simplify[XG.GRAD[h[{a,b,c,d}]]];
    goal5=2 (g2[a,b] + g2[c,d]) ((1+a a + b b)/(a b) + (1+c c + d d)/(c d))
    Print[goal5];   
    Print[Simplify[grad5-goal5]]
